if select(2, UnitClass('player')) ~= "SHAMAN" then
	return
end

local LBF = LibStub("LibButtonFacade",true)
local LSM = LibStub("LibSharedMedia-3.0",true)
local AceGUI = LibStub("AceGUI-3.0",true)
local LDB = LibStub("LibDataBroker-1.1", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Yata")
local resetkeys = {"shift", "ctrl", "alt", "none"}
function Yata:PopulateOptions()
	local options = {
	    name = "Yata",
	    handler = Yata,
	    type = 'group',
	    args = {
			lock = {
				name = L["Lock"],
				desc = L["LockDesc"],
				type = "toggle",
				get = function() return self.CurrentDb.Locked end,
				set = function(info, value)
					if(value) then
						Yata.Bar:Lock()
					else
						Yata.Bar:Unlock()
					end				
				end,
				disabled = function() return InCombatLockdown() end,
				},
			reset = {
					name = L["Reset"],
					desc = L["ResetDesc"],
					type = "execute",
					func = function() self:Reset() end,
					disabled = function() return InCombatLockdown() end
				},
			totembuttons = {
				name = L["Bindings"],
				desc = L["BindingsDesc"],
				type = "group",
				args = {
					spells = { 
						name = L["Spells"], 
						type="header", 
						order = 0,
					},
					autobuttonswap = {
						name = L["EnableAutoSwap"],
						desc = L["EnableAutoSwapDesc"],
						type = "toggle",
						get = function() return self.CurrentDb.AutoButtonSwap end,
						set = function(info, value) Yata.CurrentDb.AutoButtonSwap = value; Yata.Bar:SetAttribute("autoswap", Yata.CurrentDb.AutoButtonSwap) end,
						disabled = function() return InCombatLockdown() end,
						order = 1,
						width = "full",
					},
					buttonswapkey = {
						name = L["SwapButton"],
						desc = L["SwapButtonDesc"],
						type = "select",
						values = resetkeys,
						get = function() for k,v in ipairs(resetkeys) do if v == self.CurrentDb.ButtonSwapKey then return k end end end,
						set = function(info, value) Yata.CurrentDb.ButtonSwapKey = resetkeys[value]; Yata.Bar:SetAttribute("swapkey", Yata.CurrentDb.ButtonSwapKey) end,
						disabled = function() return InCombatLockdown() end,
						order = 2,
					},
					buttonnoswapkey = {
						name = L["CastOnly"],
						desc = L["CastOnlyDesc"],
						type = "select",
						values = resetkeys,
						get = function() for k,v in ipairs(resetkeys) do if v == self.CurrentDb.ButtonNoSwapKey then return k end end end,
						set = function(info, value) Yata.CurrentDb.ButtonNoSwapKey = resetkeys[value]; SetAttribute("noswapkey",Yata.CurrentDb.ButtonNoSwapKey) end,
						disabled = function() return (InCombatLockdown() or self.CurrentDb.AutoButtonSwap == false) end,				
						order = 3,
					},
					multicast = { 
						name = L["Multicast"], 
						type="header", 
						order = 4,
					},
					autoswaptocall = {
						name = L["EnableCallSwap"],
						desc = L["EnableCallSwapDesc"],
						type = "toggle",
						get = function() return self.CurrentDb.AutoSwapToCall end,
						set = function(info, value) Yata.CurrentDb.AutoSwapToCall = value; Yata.Bar:SetAttribute("autoswaptocall", Yata.CurrentDb.AutoSwapToCall) end,
						disabled = function() return InCombatLockdown() end,
						order = 5,
						width = "full"
					},
					manualswaptocallkey = {
						name = L["ShowCall"],
						desc = L["ShowCallDesc"],
						type = "select",
						values = resetkeys,
						get = function() for k,v in ipairs(resetkeys) do if v == self.CurrentDb.ManualSwapToCallKey then return k end end end,
						set = function(info, value) Yata.Bar:SetManualSwapToCallKey(resetkeys[value]) end,
						disabled = function() return InCombatLockdown() end,				
						order = 7,
					},
					buttonsetcallkey = {
						name = L["AssignToCall"],
						desc = L["AssignToCallDesc"],
						type = "select",
						values = resetkeys,
						get = function() for k,v in ipairs(resetkeys) do if v == self.CurrentDb.ButtonSetCallKey then return k end end end,
						set = function(info, value) Yata.CurrentDb.ButtonSetCallKey = resetkeys[value]; Yata.Bar:SetAttribute("setcallkey", Yata.CurrentDb.ButtonSetCallKey) end,
						disabled = function() return InCombatLockdown() end,
						order = 6,
					},	
				},
				order = 1,
			},
			totembar = {
				name = L["Appearance"],
				desc = L["AppearanceDesc"],
				type = "group",
				args = {
					barorientation = {
						name = L["Orientation"],
						desc = L["OrientationDesc"],
						type = "select",
						width = "double",
						values = {L["HU"], L["HD"], L["VR"], L["VL"] },
						get = function() return self.CurrentDb.BarOrientation end,
						set = function(info, value) Yata.Bar:ConfigureBarDisplay(self.CurrentDb.ButtonGap, value, self.CurrentDb.VisibleButtons) end,
						disabled = function() return InCombatLockdown() end,
						order = 0,
					},
					barscale = 	{
						name = L["Scale"],
						desc = L["ScaleDesc"],
						type = "range",
						get = function() return self.CurrentDb.BarScale end,
						set = function(info, value)
							self.CurrentDb.BarScale = value 
							self.Bar:SetScale(self.CurrentDb.BarScale)
						end,
						min = 0.5,
						max = 2.5,
						step = 0.01,
						bigStep = 0.05,
						disabled = function() return InCombatLockdown() end,
						width = "normal",
						order = 1,
					},
					popoutscale = 	{
						name = L["PopScale"],
						desc = L["PopScaleDesc"],
						type = "range",
						get = function() return self.CurrentDb.PopOutScale end,
						set = function(info, value)
							self.CurrentDb.PopOutScale = value 
							Yata.Bar:SetPopOutScale(value)
						end,
						min = 0.5,
						max = 1.5,
						step = 0.05,
						bigStep = 0.05,
						disabled = function() return InCombatLockdown() end,
						width = "normal",
						order = 2,
					},
					buttongap = {
						name = L["Gap"],
						desc = L["GapDesc"],
						type = "range",
						get = function() return self.CurrentDb.ButtonGap end,
						set = function(info, value) Yata.Bar:ConfigureBarDisplay(value, self.CurrentDb.BarOrientation, self.CurrentDb.VisibleButtons) end,
						min = -4,
						max = 8,
						step = 1,
						disabled = function() return InCombatLockdown() end,
						width = "double",
						order = 4,
					},					
					visiblebuttons = {
						name = L["SpellCount"],
						desc = L["SpellCountDesc"],
						type = "range",
						get = function() return self.CurrentDb.VisibleButtons end,
						set = function(info, value) Yata.Bar:ConfigureBarDisplay(self.CurrentDb.ButtonGap, self.CurrentDb.BarOrientation, value) end,
						min = 1,
						max = 10,
						step = 1,
						disabled = function() return InCombatLockdown() end,	
						width = "double",
						order = 3,
					},
					shorttooltip = {
						name = L["Tooltip"],
						desc = L["TooltipDesc"],
						type = "select",
						width = "double",
						values = {L["TooltipNone"], L["TooltipShort"], L["TooltipFull"] },
						get = function() return self.CurrentDb.Tooltip end,
						set = function(info, value) self.CurrentDb.Tooltip = value end,
						disabled = function() return InCombatLockdown() end,
						order = 5,
					},
				},
				order = 0,				
			},
			totemtimers = {
				name = L["Timers"],
				desc = L["TimersDesc"],
				type = "group",
				args = {
					enabletimers = {
						name = L["EnableTimers"],
						desc = L["EnableTimersDesc"],
						type = "toggle",
						get = function() return self.CurrentDb.TimerEnabled end,
						set = function(info, value) self.CurrentDb.TimerEnabled = value end,
						disabled = function() return InCombatLockdown() end,
						order = 0,
						width = "full",
					},
					timerscale = 	{
						name = L["TimerScale"],
						desc = L["TimerScaleDesc"],
						type = "range",
						get = function() return self.CurrentDb.TimerScale end,
						set = function(info, value)
							self.CurrentDb.TimerScale = value 
							self:SetTimerScale(self.CurrentDb.TimerScale)
						end,
						min = 0.5,
						max = 2.5,
						step = 0.01,
						bigStep = 0.05,
						disabled = function() return (InCombatLockdown() or self.CurrentDb.TimerEnabled == false or self.CurrentDb.TimerType == 2) end,
						order = 2,
					},					
					timertype = {
						name = L["TimerType"],
						desc = L["TimerTypeDesc"],
						type = "select",
						values = {L["TimerBars"], L["TimerSelf"]},
						get = function() return self.CurrentDb.TimerType end,
						set = function(info, value) self.CurrentDb.TimerType = value end,
						disabled = function() return (InCombatLockdown() or self.CurrentDb.TimerEnabled == false) end,
						order = 1,
						width = "double",
					},					
				},
				order = 2,
			},
			totemmacro = {
				name = L["Macro"],
				desc = L["MacroDesc"],
				type = "group",
				args = {
					resetkey = {
						name = L["MacroReset"],
						desc = L["MacroResetDesc"],
						type = "select",
						values = resetkeys,
						get = function() for k,v in ipairs(resetkeys) do if v == self.CurrentDb.MacroResetKey then return k end end end,
						set = function(info, value) local oldKey = self.CurrentDb.MacroResetKey self.CurrentDb.MacroResetKey = resetkeys[value] Yata.Bar:EditMacro(oldKey, self.CurrentDb.MacroResetKey) end,
						disabled = function() return InCombatLockdown() end,
					},
				},
				order = 3,
			},
			totemsets = {
				name = L["TotemSets"],
				desc = L["TotemSetsDesc"],
				type = "group",
				args = {
					totemlayout = {
						name = L["TotemSetsButton"],
						desc = L["TotemSetsButtonDesc"],
						type = "execute",
						func = function() local editor = AceGUI:Create("Yata_TotemButtonLayoutEditor") end,
						disabled = function() return InCombatLockdown() end,
					},				},
				order = 4,
			},
		},
	}
	if LBF then
		buttonskin = {
			name = L["Skin"],
			desc = L["SkinDesc"],
			type = "select",
			values = function() return LBF:ListSkins() end,
			get = function() return self.CurrentDb.ButtonSkin  end,
			set = function(info, value) Yata.Bar:SkinButtons(value) end,
			disabled = function() return InCombatLockdown() end,
			width = "double",
			order = 2,
		}
		options.args.totembar.args["buttonskin"] = buttonskin
	end
	if LSM then
		timerbarskin = {
			name = L["TimerTexture"],
			desc = L["TimerTextureDesc"],
			type = "select",
			values = function() return LSM:List("statusbar") end,
			get = function() for k,v in ipairs(LSM:List("statusbar")) do if v == self.CurrentDb.TimerBarSkin then return k end end end,
			set = function(info, value) self.CurrentDb.TimerBarSkin = LSM:List("statusbar")[value] self:LoadTimerConfig() end,
			disabled = function() return (InCombatLockdown() or self.CurrentDb.TimerEnabled == false or self.CurrentDb.TimerType == 2) end,
			order = 3,
		}
		options.args.totemtimers.args["timerbarskin"] = timerbarskin
	end
	return options
end 

-- Adapted from Nevcairiel's Bartender4
if LDB then
	LibStub("LibDataBroker-1.1"):NewDataObject("Yata", {
		type = "launcher",
		text = "Yata",
		label = "Yata",
		OnClick = function(_, msg)
			if msg == "LeftButton" then
				if Yata.CurrentDb.Locked then
					Yata.Bar:Unlock()
				else
					Yata.Bar:Lock()
				end
			elseif msg == "RightButton" then
				if LibStub("AceConfigDialog-3.0").OpenFrames["Yata"] then
					LibStub("AceConfigDialog-3.0"):Close("Yata")
				else
					LibStub("AceConfigDialog-3.0"):Open("Yata")
				end
			end
		end,
		icon = "Interface\\Icons\\Spell_Nature_EarthBindTotem",
		OnTooltipShow = function(tooltip)
			if not tooltip or not tooltip.AddLine then return end
			tooltip:AddLine("Yata")
			tooltip:AddLine(L["BrokerLock"])
			tooltip:AddLine(L["BrokerOptions"])
		end,
	})
end

	StaticPopupDialogs["Yata_AddSet"] = {
		text = L["NewSetName"],
		button1 = ACCEPT,
		button2 = CANCEL,
		timeout = 0,
		hasEditBox = 1,
		whileDead = 1,
		hideOnEscape = 1,
		OnAccept = function(self,data) this:GetParent().data:AddSet(getglobal(this:GetParent():GetName().."EditBox"):GetText()) end,
		OnCancel = function() end,
	}
	
	StaticPopupDialogs["Yata_DelSet"] = {
		text = L["DeleteSetName"],
		button1 = ACCEPT,
		button2 = CANCEL,
		timeout = 0,
		hasEditBox = 1,
		whileDead = 1,
		hideOnEscape = 1,
		OnAccept = function(self,data) this:GetParent().data:DelSet(getglobal(this:GetParent():GetName().."EditBox"):GetText()) end,
		OnCancel = function() end,
	}